@ECHO off

REM Jim Cornmell - 2003

REM Simple demo to show how to use the DDE interface in CDC.
REM It simply tries all of the available commands.

CLS

ECHO.
ECHO This script will take you though all of the CDC DDE commands using the
ECHO CDCcmd interface.  When asked press return to execute next command.
ECHO.

ECHO Please make sure CDC is started?
PAUSE
ECHO.

ECHO The following will print the help info for CDCcmd.
PAUSE
ECHO.
CDCcmd
ECHO.

ECHO The following will centre the screen on Gemini and save the chart.
PAUSE
ECHO.
CDCcmd MOVE RA: 07h00m00.00s DEC:+2500'00.0\" FOV:+3500'00\"
CDCcmd SAVE gemini
ECHO.

ECHO The following will centre the screen on Orion and save the chart.
PAUSE
ECHO.
CDCcmd MOVE RA: 05h36m12.80s DEC:-0112'07.0\" FOV:+3500'00\"
CDCcmd SAVE orion
ECHO.

ECHO The following will reload the gemini chart and then the orion one.
PAUSE
ECHO.
CDCcmd LOAD gemini
PAUSE
CDCcmd LOAD orion
ECHO.

ECHO The following will find Messier 1, and save the screen image to various formats in C:\.
PAUSE
CDCcmd FIND CAT: 1 ID: 1
CDCcmd SGIF C:\image.gif
CDCcmd SBMP C:\image.bmp
CDCcmd SJPG C:\imagelo.jpg 1
CDCcmd SJPG C:\imagehi.jpg 100
dir C:\image*.*
ECHO.

ECHO The following commands will change the display in some way...
ECHO Zooming in.
PAUSE
CDCcmd ZOM+
CDCcmd ZOM+
CDCcmd ZOM+
ECHO.

ECHO Zooming out.
PAUSE
CDCcmd ZOM-
CDCcmd ZOM-
CDCcmd ZOM-
ECHO.

ECHO More stars.
PAUSE
CDCcmd STA+
CDCcmd STA+
CDCcmd STA+
ECHO.

ECHO Less stars.
PAUSE
CDCcmd STA-
CDCcmd STA-
CDCcmd STA-
ECHO.

ECHO More nebulae.
PAUSE
CDCcmd NEB+
CDCcmd NEB+
CDCcmd NEB+
ECHO.

ECHO Less nebulae.
PAUSE
CDCcmd NEB-
CDCcmd NEB-
CDCcmd NEB-
ECHO.

ECHO (load orion chart and then) Toggle the equatorial grid.
PAUSE
CDCcmd LOAD orion
CDCcmd GREQ
ECHO.

ECHO Toggle the azimuthal grid.
PAUSE
CDCcmd GRAZ
ECHO.

ECHO Toggle the grid numbers.
PAUSE
CDCcmd GRNM
ECHO.

ECHO Toggle constellation lines.
PAUSE
CDCcmd CONL
ECHO.

ECHO Toggle constellation border lines.
PAUSE
CDCcmd CONB
ECHO.

ECHO Toggle equatorial/azimuthal projection.
PAUSE
CDCcmd EQAZ
ECHO.

ECHO Set the date to 2003-04-05 at 01:02:03
PAUSE
CDCcmd DATE 2003-04-05T01:02:03
ECHO.

ECHO Set the observatory to some locaion.
PAUSE
CDCcmd OBSL LAT:+01d02m03.4s LON:+05d06m07.8s ALT:009mOBS: Somewhere
ECHO.

ECHO Identify object at pixel location.
PAUSE
CDCcmd IDXY X:200 Y:200
ECHO.

ECHO Centre on pixel location.
PAUSE
CDCcmd GOXY X:100 Y:200
ECHO.

REM Unable to test the following since I do not have a DSS CD.
REM CDCcmd PDSS CDdrive ImagePath ImageName reuse

ECHO Demo completed.
PAUSE
