///////////////////////////////////////
// CDCcmd v1.0 - Jim Cornmell - 2003 //
///////////////////////////////////////

#include "stdafx.h"
#include "CDCcmd.h"
#include "DDEML.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// Talk to CDC via the MFC DDE commands.
void CDCPoke(CString cmd)
{
	// get the pidInst and do init;
	DWORD pidInst = 0;
	DdeInitialize(&pidInst, NULL, APPCLASS_MONITOR, 0);

	// Setup some HSZ strings to connect to CDC.
	HSZ hServer = DdeCreateStringHandle(pidInst, "ciel",        CP_WINANSI);
	HSZ hTopic  = DdeCreateStringHandle(pidInst, "DdeSkyChart", CP_WINANSI);
	HSZ hData   = DdeCreateStringHandle(pidInst, "DdeData",     CP_WINANSI);

	// Preform connect.
	HCONV hConv = DdeConnect(pidInst, hServer, hTopic, NULL);

	// Did we connect OK...?
	if(hConv == NULL) {
		// ...Nope, so generate error message..
		cerr << "ERROR: Unable to connect to Cartes du Ciel!  Is it running?" << endl;
	} else {
		// ...Yep, so lets send the command via a DDE poke.
		DdeClientTransaction((LPBYTE)(LPCTSTR)cmd, strlen(cmd)+1, hConv, hData, CF_TEXT, XTYP_POKE, 1000, NULL);
	}

	// Close DDE connection.
	DdeDisconnect(hConv);

	// Free up the strings created above.
	DdeFreeStringHandle(pidInst, hServer);
	DdeFreeStringHandle(pidInst, hTopic);
	DdeFreeStringHandle(pidInst, hData);

	// Do final close.
	DdeUninitialize(pidInst);
}

/////////////////////////////////////////////////////////////////////////////
// Print the usage if no arguments supplied.
void Usage()
{
	cout << "CDCcmd v1.0 - Jim Cornmell - 2003" << endl << endl;
	cout << "USAGE: CDCcmd command" << endl << endl;
	cout << "The following is a complete list of all CDC DDE commands." << endl << endl;
	cout << "CDCcmd" << endl;
	cout << "CDCcmd MOVE RA: 00h00m00.00s DEC:-0000'00.0\" FOV:+0000'00\"" << endl;
	cout << "CDCcmd FIND CAT: <catid> ID: <objid>" << endl;
	cout << "CDCcmd DATE YYYY-MM-DDTHH:MM:SS" << endl;
	cout << "CDCcmd OBSL LAT:+00d00m00.0s LON:+00d00m00.0s ALT:000mOBS: <obs name>" << endl;
	cout << "CDCcmd PDSS <cddrive> <imagepath> <imagename> <reuse>" << endl;
	cout << "CDCcmd SBMP <imagename.bmp>" << endl;
	cout << "CDCcmd SGIF <imagename.gif>" << endl;
	cout << "CDCcmd SJPG <imagename.jpg> <quality 1=lowest 100=highest>" << endl;
	cout << "CDCcmd IDXY X:<pixelx> Y:200<pixely>" << endl;
	cout << "CDCcmd GOXY X:<pixelx> Y:<pixely>" << endl;
	cout << "CDCcmd ZOM+" << endl;
	cout << "CDCcmd ZOM-" << endl;
	cout << "CDCcmd STA+" << endl;
	cout << "CDCcmd STA-" << endl;
	cout << "CDCcmd NEB+" << endl;
	cout << "CDCcmd NEB-" << endl;
	cout << "CDCcmd GREQ" << endl;
	cout << "CDCcmd GRAZ" << endl;
	cout << "CDCcmd GRNM" << endl;
	cout << "CDCcmd CONL" << endl;
	cout << "CDCcmd CONB" << endl;
	cout << "CDCcmd EQAZ" << endl;
	cout << "CDCcmd LOAD <chartname>" << endl;
	cout << "CDCcmd SAVE <chartname>" << endl << endl;
	cout << "For more information on each command refer to the CDC manual pages." << endl;
}

// Main program.
int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)) {
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	} else {
		// Make sure we have some arguments if not display some help to the user.
		if (argc < 2) {
			Usage();
			return nRetCode;
		}

		// Build up DDE command from all of the arguments.
		CString cmd = "";

		for (int i = 1; i < argc; i++) {
			cmd += argv[i] + CString(" ");
		}

		// Remove any space on the right.
		cmd.TrimRight();

		// Execute the command via DDE.
		CDCPoke(cmd);
	}

	return nRetCode;
}
